#!/usr/bin/perl
# Made by Hojin Choi <hojin.choi@gmail.com>
# $Id$

if( $#ARGV != 1 )
{
	print "Usage: $0 <po file> <text template>\n";
	exit 1;
}

$po_file = $ARGV[0];
$text_template = $ARGV[1];

open TMPL, $text_template or die "No template release notes template: $text_template";

while( <TMPL> )
{
	s/^\s+//;
	s/\s+$//;
	$releasenote .= $_ . "__NEWLINE__";
}

close( TMPL );

open PO, $po_file or die "No po file: $po_file";

while( <PO> )
{
	$po_line_count++;
	chomp;
	next if /^#/;

	if( $state == 0 )
	{
		next unless /^msgid\s+(.+)/;
		$state = 1;
		$msgid = $1;
		$msgid =~ s/^\"//;
		$msgid =~ s/\"$//;
		next;
	}
	if( $state == 1 )
	{
		if( /^msgstr\s+(.+)/ )
		{
			$msgstr = $1;
			$msgstr =~ s/^\"//;
			$msgstr =~ s/\"$//;
			$state = 2;
		}
		else
		{
			s/^\"//;
			s/\"$//;
			$msgid .= $_;
		}
		next;
	}
	if( $state == 2 )
	{
		if( /^\s*$/ )
		{
			if( $msgid ne "\"\"" )
			{
				$msgstr{$msgid} = $msgstr;
				if( $msgstr eq "" )
				{
					$msgstr{$msgid} = $msgid;
				}
			}
			$state = 0;
		}
		else
		{
			s/^\"//;
			s/\"$//;
			$msgstr .= $_;
		}
	}
}

while( $releasenote =~ /(.*?)<translate>(.+?)<\/translate>(.*)/ )
{
	$before = $1;
	$after = $3;
	$msgid = $2;
	$msgid =~ s/"/\\\"/mg;
	$msgid =~ s/__NEWLINE__/\\n/mg;
	$msgstr = $msgstr{$msgid};
	$msgstr = $msgid unless $msgstr;
	$releasenote = "$before$msgstr$after";
}

$releasenote =~ s/__NEWLINE__/\n/mg;
$releasenote =~ s/\\n/\n/mg;

print $releasenote;

